Bug 520569 - Review Request: uboot-tools - U-Boot utilities
Summary: Review Request: uboot-tools - U-Boot utilities
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Chris Tyler
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: u-boot-tools (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-09-01 07:28 UTC by Dan Horák
Modified: 2010-06-04 14:27 UTC (History)
10 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-06-04 14:27:55 UTC
ctyler.fedora: fedora-review+
kevin: fedora-cvs+


Attachments (Terms of Use)

Description Dan Horák 2009-09-01 07:28:26 UTC
Spec URL: http://fedora.danny.cz/uboot-mkimage.spec
SRPM URL: http://fedora.danny.cz/uboot-mkimage-0.4-1.fc12.src.rpm

Description:
U-Boot mkimage utility

Comment 1 Dan Horák 2009-09-01 07:29:32 UTC
*** Bug 448661 has been marked as a duplicate of this bug. ***

Comment 2 Josh Boyer 2009-09-01 11:46:29 UTC
I'm not really thrilled with this package.  It is very hard to determine what version of U-Boot the mkimage utility has been derived from.  Looking it over, it seems to lack support for the FIT images.  It also looks like it is derived from the openwrt project instead of the actual upstream U-Boot project.

Comment 3 Dan Horák 2009-09-01 12:26:07 UTC
Yes, the history of the code is a bit complicated, originally in U-Boot, then in openwrt and now maintained and used by Debian.

Josh, if you think it would be better to use mkimage from the recent U-Boot, I can switch to it. It looked as overkill to me to carry 8+ MB of sources for just this little utility. I know, disk space is cheap ...

Comment 4 Josh Boyer 2009-09-01 13:49:08 UTC
I agree that carrying the full source is excessive.  However, the way mkimage is built requires you to configure U-Boot for a board first.  Newer versions also rely on the libfdt support in the U-Boot source code.  So creating a trimmed down package can be done, but it would need to be done carefully.

The config part is the trickiest.  Configuring it for e.g. and i686 board may not be what you want if you are trying to build a PowerPC uImage, etc.  I don't know off the top of my head, but some inspection would be needed if this were to be done in a general fashion.

Comment 5 Dan Horák 2009-09-01 15:30:56 UTC
After a brief look into the code it looks to me that mkimage doesn't depend on the configured board, libfdt and mkimage are build with USE_HOSTCC defined and mkimage uses its own *.o for libfdt code. Thus IMHO it could be safe to configure u-boot for any board.

Comment 6 Dan Horák 2009-11-14 10:09:26 UTC
New release is available, now based on the official U-Boot sources. It includes both mkimage and the environment r/w tool. This is really a work-in-progress and the final look of the package should be discussed between the interested parties.

Spec URL: http://fedora.danny.cz/uboot-tools.spec
SRPM URL: http://fedora.danny.cz/uboot-tools-2009.08-1.fc12.src.rpm

Comment 7 Chris Tyler 2010-05-27 17:36:48 UTC
We need mkimage for kernel building for ARM and for the ESIA package.

Review results:

[N] MUST: rpmlint must be run on every package. The output should be posted in the review.[1]

*** rpmlint output:
$ rpmlint */uboot*spec */uboot*rpm */*/uboot*rpm
uboot-tools.x86_64: W: no-documentation
3 packages and 1 specfiles checked; 0 errors, 1 warnings.

[Y] MUST: The package must be named according to the Package Naming Guidelines .
[Y] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .
[Y] MUST: The package must meet the Packaging Guidelines .
[Y] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[Y] MUST: The License field in the package spec file must match the actual license. [3]
[N] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
[Y] MUST: The spec file must be written in American English. [5]
[Y] MUST: The spec file for the package MUST be legible. [6]
[Y] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
[Y] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
[Y] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]
[Y] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[NA] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
[NA] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
[Y] MUST: Packages must NOT bundle copies of system libraries.[11]
[NA] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [12]
[Y] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]
[Y] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. [14]
[Y] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [15]
[N] MUST: Each package must consistently use macros. [16]

*** Avoid mixing environment variables ($RPMBUILDROOT) with macros (e.g., use %{buildroot})

[Y] MUST: The package must contain code, or permissable content. [17]
[NA] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
[NA] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]

*** !No %doc present

[NA] MUST: Header files must be in a -devel package. [19]
[NA] MUST: Static libraries must be in a -static package. [20]
[NA] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [19]
[NA] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} [21]
[NA] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]
[NA] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [22]
[NA] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [23]
[Y] MUST: All filenames in rpm packages must be valid UTF-8. [24]
[Y] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [25]
[NA] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [26]
[Y] SHOULD: The reviewer should test that the package builds in mock. [27]
[-] SHOULD: The package should compile and build into binary rpms on all supported architectures. [28]
[-] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[NA] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [29]
[NA] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [21]
[NA] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. [30]
[NA] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [31]
[N] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.[32]

Additional comments:
- Should have a more detailed %desc/%summary

Comment 8 Dan Horák 2010-05-27 19:48:24 UTC
(In reply to comment #7)
> We need mkimage for kernel building for ARM and for the ESIA package.

Thanks for the review and did you checked the uboot-tools package based on the U-Boot source code?


> [N] MUST: Each package must consistently use macros. [16]
> 
> *** Avoid mixing environment variables ($RPMBUILDROOT) with macros (e.g., use
> %{buildroot})

using $RPM_BUILD_ROOT and %{_*dir} is valid, the guideline doesn't to see using both $RPM_BUILD_ROOT and %{buildroot} in one spec
 
> [Y] MUST: The package must contain code, or permissable content. [17]
> [NA] MUST: Large documentation files must go in a -doc subpackage. (The
> definition of large is left up to the packager's best judgement, but is not
> restricted to size. Large can refer to either size or quantity). [18]
> [NA] MUST: If a package includes something as %doc, it must not affect the
> runtime of the application. To summarize: If it is in %doc, the program must
> run properly if it is not present. [18]
> 
> *** !No %doc present

yes, I will add some and I open to suggestions what should be included

> 
> Additional comments:
> - Should have a more detailed %desc/%summary    

will be updated

Comment 9 Dan Horák 2010-05-30 08:09:22 UTC
Updated Spec URL: http://fedora.danny.cz/uboot-tools.spec
Updated SRPM URL: http://fedora.danny.cz/uboot-tools-2010.03-1.fc14.src.rpm

ChangeLog:
- updated to U-Boot 2010.03
- updated Summary, added docs
- resolved issues when a cross-compiler would be called

Comment 10 Chris Tyler 2010-06-02 02:58:51 UTC
[Y] MUST: rpmlint must be run on every package. The output should be posted in
the review.[1]

$ rpmlint RPMS/*/* SRPMS/* SPECS/uboot-tools.spec 
uboot-tools.i686: W: spelling-error %description -l en_US fw -> f, w, few
uboot-tools.i686: W: spelling-error %description -l en_US printenv -> printer, printing, printable
uboot-tools.i686: W: spelling-error %description -l en_US setenv -> Seton, setter, settee
uboot-tools.src: W: spelling-error %description -l en_US mkimage -> imagery, image, imagine
uboot-tools.src: W: spelling-error %description -l en_US fw -> f, w, few
uboot-tools.src: W: spelling-error %description -l en_US printenv -> printer, printing, printable
uboot-tools.src: W: spelling-error %description -l en_US setenv -> Seton, setter, settee
3 packages and 1 specfiles checked; 0 errors, 7 warnings.

[Y] MUST: The package must be named according to the Package Naming Guidelines.
[Y] MUST: The spec file name must match the base package %{name}, in the format
%{name}.spec unless your package has an exemption. [2] .
[Y] MUST: The package must meet the Packaging Guidelines .
[Y] MUST: The package must be licensed with a Fedora approved license and meet
the Licensing Guidelines .
[Y] MUST: The License field in the package spec file must match the actual
license. [3]
[Y] MUST: If (and only if) the source package includes the text of the
license(s) in its own file, then that file, containing the text of the
license(s) for the package must be included in %doc.[4]
[Y] MUST: The spec file must be written in American English. [5]

*** Recommend improving grammar in the %desc in two places-- change to:

This package contains a few U-Boot utilities - mkimage for creating boot images
and fw_printenv/fw_setenv for manipulating the boot environment variables.

[Y] MUST: The spec file for the package MUST be legible. [6]
[Y] MUST: The sources used to build the package must match the upstream source,
as provided in the spec URL. Reviewers should use md5sum for this task. If no
upstream URL can be specified for this package, please see the Source URL
Guidelines for how to deal with this.
[Y] MUST: The package MUST successfully compile and build into binary rpms on
at least one primary architecture. [7]
[Y] MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in
bugzilla, describing the reason that the package does not compile/build/work on
that architecture. The bug number MUST be placed in a comment, next to the
corresponding ExcludeArch line. [8]
[Y] MUST: All build dependencies must be listed in BuildRequires, except for
any that are listed in the exceptions section of the Packaging Guidelines ;
inclusion of those as BuildRequires is optional. Apply common sense.
[NA] MUST: The spec file MUST handle locales properly. This is done by using
the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
[NA] MUST: Every binary RPM package (or subpackage) which stores shared library
files (not just symlinks) in any of the dynamic linker's default paths, must
call ldconfig in %post and %postun. [10]
[Y] MUST: Packages must NOT bundle copies of system libraries.[11]
[NA] MUST: If the package is designed to be relocatable, the packager must
state this fact in the request for review, along with the rationalization for
relocation of that specific package. Without this, use of Prefix: /usr is
considered a blocker. [12]
[Y] MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which does
create that directory. [13]
[Y] MUST: A Fedora package must not list a file more than once in the spec
file's %files listings. [14]
[Y] MUST: Permissions on files must be set properly. Executables should be set
with executable permissions, for example. Every %files section must include a
%defattr(...) line. [15]
[Y] MUST: Each package must consistently use macros. [16]
[Y] MUST: The package must contain code, or permissable content. [17]
[NA] MUST: Large documentation files must go in a -doc subpackage. (The
definition of large is left up to the packager's best judgement, but is not
restricted to size. Large can refer to either size or quantity). [18]
[NA] MUST: If a package includes something as %doc, it must not affect the
runtime of the application. To summarize: If it is in %doc, the program must
run properly if it is not present. [18]
[NA] MUST: Header files must be in a -devel package. [19]
[NA] MUST: Static libraries must be in a -static package. [20]
[NA] MUST: If a package contains library files with a suffix (e.g.
libfoo.so.1.1), then library files that end in .so (without suffix) must go in
a -devel package. [19]
[NA] MUST: In the vast majority of cases, devel packages must require the base
package using a fully versioned dependency: Requires: %{name} =
%{version}-%{release} [21]
[NA] MUST: Packages must NOT contain any .la libtool archives, these must be
removed in the spec if they are built.[20]
[NA] MUST: Packages containing GUI applications must include a %{name}.desktop
file, and that file must be properly installed with desktop-file-install in the
%install section. If you feel that your packaged GUI application does not need
a .desktop file, you must put a comment in the spec file with your explanation.
[22]
[NA] MUST: Packages must not own files or directories already owned by other
packages. The rule of thumb here is that the first package to be installed
should own the files or directories that other packages may rely upon. This
means, for example, that no package in Fedora should ever share ownership with
any of the files or directories owned by the filesystem or man package. If you
feel that you have a good reason to own a file or directory that another
package owns, then please present that at package review time. [23]
[Y] MUST: All filenames in rpm packages must be valid UTF-8. [24]
[Y] SHOULD: If the source package does not include license text(s) as a
separate file from upstream, the packager SHOULD query upstream to include it.
[25]
[NA] SHOULD: The description and summary sections in the package spec file
should contain translations for supported Non-English languages, if available.
[26]
[Y] SHOULD: The reviewer should test that the package builds in mock. [27]
[-] SHOULD: The package should compile and build into binary rpms on all
supported architectures. [28]
[-] SHOULD: The reviewer should test that the package functions as described. A
package should not segfault instead of running, for example.
[NA] SHOULD: If scriptlets are used, those scriptlets must be sane. This is
vague, and left up to the reviewers judgement to determine sanity. [29]
[NA] SHOULD: Usually, subpackages other than devel should require the base
package using a fully versioned dependency. [21]
[NA] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase,
and this is usually for development purposes, so should be placed in a -devel
pkg. A reasonable exception is that the main pkg itself is a devel tool not
installed in a user runtime, e.g. gcc or gdb. [30]
[NA] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin,
/usr/bin, or /usr/sbin consider requiring the package which provides the file
instead of the file itself. [31]
[N] SHOULD: your package should contain man pages for binaries/scripts. If it
doesn't, work with upstream to add them where they make sense.[32]

APPROVED

Comment 11 Dan Horák 2010-06-02 09:45:49 UTC
New Package CVS Request
=======================
Package Name: uboot-tools
Short Description: U-Boot utilities
Owners: sharkcz
Branches: F-12 F-13 EL-5 EL-6
InitialCC:

Comment 12 Dan Horák 2010-06-02 09:49:24 UTC
Chris, thanks for the review.

Comment 13 Kevin Fenzi 2010-06-03 20:10:24 UTC
CVS done (by process-cvs-requests.py).

Comment 14 Dan Horák 2010-06-04 14:27:55 UTC
imported and built with the updated description


Note You need to log in before you can comment on or make changes to this bug.